; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     80x87 Frac Routine                              *
; *                                                     *
; *     Copyright (C) 2001-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   F87HFRC

             INCLUDE SE.ASM

             .386
             .387

        if Emul87
             EMUL
        else
             NOEMUL
        endif

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  FFrac

; Frac function

FFrac        PROC    FAR

             push    ax
             mov     bx, sp
             fstcw   ss:[bx]           ; save current FPU control word
             fldcw   CWChop
             fld     st(0)
             frndint
             fsub
             fldcw   ss:[bx]           ; restore previous FPU control word
             add     sp, 2
             ret

FFrac        ENDP

; Chop rounding control word

CWChop       dw      1f3fh

             INCLUDE ALIGN.ASM

CODE         ENDS

             END