; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0/7.0    *
; *     Character Handling Routines                     *
; *                                                     *
; *     Copyright (C) 1991-1994 Norbert Juffa           *
; *     Copyright (C) 2000-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   CHAR

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Publics

             PUBLIC  UpperCase

;-------------------------------------------------------------------------------
; UpCase standard function: UpCase (Ch: CHAR): CHAR
;
; UpperCase represents the UpCase standard function.
;
; [RAHP: Removed codepage 437 uppercase translations]
;
; On entry:  [SP+4]  input character
;
; On exit:   AL      input character converted to upper case
;-------------------------------------------------------------------------------

UpperCase    PROC    FAR

             mov     bx, sp            ; new frame pointer
             mov     al, ss:[bx + 4]   ; get character
             sub     al, 'a'
             sub     al, 26
             sbb     cl, cl
             and     cl, 0e0h
             add     al, 'a' + 26
             add     al, cl
             ret     2

UpperCase    ENDP

             INCLUDE ALIGN.ASM

CODE         ENDS

             END