; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 7.0        *
; *     Hardware Emulator Initialization                *
; *                                                     *
; *     Copyright (C) 2002-2003 Robert AH Prins         *
; *                                                     *
; *******************************************************

             TITLE   EI8X

             INCLUDE SE.ASM

             .386

CODE         SEGMENT BYTE PUBLIC USE16
             ASSUME  CS:CODE

; Externals

             EXTRN   Check8087    : NEAR
             EXTRN   Init8087     : NEAR
             EXTRN   HaltTurbo    : NEAR
             EXTRN   E087_Entry   : NEAR
             EXTRN   E087_Shortcut: NEAR

; Publics

             PUBLIC  InitEM87
             PUBLIC  InitEM86

; Initialize hardware emulator. Called right after main startup
; code by programs compiled in the {$N+,E+/-} state.

InitEM86:
InitEM87:

             call    Check8087
             mov     si, offset E087_Entry
             mov     di, offset E087_Shortcut
             cmp     al, 3
             jae     Init8087

             push    ds
             mov     dx, offset cs:NoFPU
             push    cs
             pop     ds
             mov     ah, 9
             int     dos
             pop     ds
             mov     ax, 255
             jmp     HaltTurbo

; 80x87 error string

NoFPU        db      '32-bit FPU required',cr,lf,'$'

             INCLUDE ALIGN.ASM

CODE         ENDS

             END